<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Groups &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Guests" href="heiwa.views.guest.html" />
    <link rel="prev" title="Forums" href="heiwa.views.forum.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="heiwa.html">API Documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="heiwa.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3 current"><a class="reference internal" href="heiwa.views.html">API views</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.category.html">Categories</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.file.html">Files</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.forum.html">Forums</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Groups</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.guest.html">Guests</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.message.html">Messages</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.meta.html">Meta information</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.notification.html">Notifications</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.oidc.html">OIDC</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.post.html">Posts</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.statistic.html">Statistics</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.thread.html">Threads</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.user.html">Users</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.utils.html">Utilities</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#module-heiwa">Root</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="heiwa.html">API Documentation</a> &raquo;</li>
          <li><a href="heiwa.views.html">API views</a> &raquo;</li>
      <li>Groups</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/heiwa.views.group.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="module-heiwa.views.group">
<span id="groups"></span><h1>Groups<a class="headerlink" href="#module-heiwa.views.group" title="Permalink to this headline"></a></h1>
<p>API views for <a class="reference internal" href="heiwa.database.html#heiwa.database.Group" title="heiwa.database.Group"><code class="xref py py-class docutils literal notranslate"><span class="pre">Group</span></code></a>s.</p>
<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.create">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">create</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#create"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.create" title="Permalink to this definition"></a></dt>
<dd><p>Creates a group with the requested <code class="docutils literal notranslate"><span class="pre">name</span></code>, <code class="docutils literal notranslate"><span class="pre">description</span></code>,
<code class="docutils literal notranslate"><span class="pre">default_for</span></code> and <code class="docutils literal notranslate"><span class="pre">level</span></code> attributes.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The newly created group, with the HTTP <code class="docutils literal notranslate"><span class="pre">201</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.delete">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">delete</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#delete"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.delete" title="Permalink to this definition"></a></dt>
<dd><p>Deletes the group with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Group.id" title="heiwa.database.Group.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the group.</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIGroupIsLastDefault" title="heiwa.exceptions.APIGroupIsLastDefault"><strong>heiwa.exceptions.APIGroupIsLastDefault</strong></a> – Raised when the group is the
last one whose <a class="reference internal" href="heiwa.database.html#heiwa.database.Group.default_for" title="heiwa.database.Group.default_for"><code class="xref py py-attr docutils literal notranslate"><span class="pre">default_for</span></code></a>
attribute contains <code class="docutils literal notranslate"><span class="pre">*</span></code>, meaning it’s default for all users.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, with the HTTP <code class="docutils literal notranslate"><span class="pre">204</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.edit">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">edit</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#edit"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.edit" title="Permalink to this definition"></a></dt>
<dd><p>Updates the group with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Group.id" title="heiwa.database.Group.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the group.</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIGroupUnchanged" title="heiwa.exceptions.APIGroupUnchanged"><strong>heiwa.exceptions.APIGroupUnchanged</strong></a> – Raised when no attributes of
the group would be changed, should the function continue.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The updated group, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.list_">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">list_</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#list_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.list_" title="Permalink to this definition"></a></dt>
<dd><p>Gets all groups that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to view
and match the requested filter, if one is given.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of groups, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.mass_delete">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">mass_delete</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#mass_delete"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.mass_delete" title="Permalink to this definition"></a></dt>
<dd><p>Deletes all groups that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to.
If there is a filter requested, they must also match it.</p>
<p>The last (as per the given order) group which is default for <code class="docutils literal notranslate"><span class="pre">*</span></code> is
excluded.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.mass_edit">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">mass_edit</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#mass_edit"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.mass_edit" title="Permalink to this definition"></a></dt>
<dd><p>Updates all groups that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to.
If there is a filter requested, they must also match it.</p>
<p>If <code class="docutils literal notranslate"><span class="pre">default_for</span></code> is being edited and does not contain <code class="docutils literal notranslate"><span class="pre">*</span></code>, the last
(as per the given order) group which is default for <code class="docutils literal notranslate"><span class="pre">*</span></code> is excluded.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.view">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">view</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#view"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.view" title="Permalink to this definition"></a></dt>
<dd><p>Gets the group with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Group.id" title="heiwa.database.Group.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the group.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The group, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.view_allowed_actions_instance">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">view_allowed_actions_instance</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#view_allowed_actions_instance"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.view_allowed_actions_instance" title="Permalink to this definition"></a></dt>
<dd><p>Gets all actions that <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is authorized to perform on
the group with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Group.id" title="heiwa.database.Group.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the group.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The list of allowed actions, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.view_allowed_actions_static">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.</span></span><span class="sig-name descname"><span class="pre">view_allowed_actions_static</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group.html#view_allowed_actions_static"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.view_allowed_actions_static" title="Permalink to this definition"></a></dt>
<dd><p>Gets all actions that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is authorized to
perform on all groups, without any knowledge of their identity.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of allowed actions, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<section id="module-heiwa.views.group.permissions">
<span id="permissions"></span><h2>Permissions<a class="headerlink" href="#module-heiwa.views.group.permissions" title="Permalink to this headline"></a></h2>
<p>API views for <a class="reference internal" href="heiwa.database.html#heiwa.database.GroupPermissions" title="heiwa.database.GroupPermissions"><code class="xref py py-class docutils literal notranslate"><span class="pre">GroupPermissions</span></code></a>,
belonging under the default set of views for
<a class="reference internal" href="heiwa.database.html#heiwa.database.Group" title="heiwa.database.Group"><code class="xref py py-class docutils literal notranslate"><span class="pre">Group</span></code></a>s.</p>
<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.permissions.delete">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.permissions.</span></span><span class="sig-name descname"><span class="pre">delete</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group/permissions.html#delete"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.permissions.delete" title="Permalink to this definition"></a></dt>
<dd><p>Deletes the group with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>’s permissions.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.permissions.edit">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.permissions.</span></span><span class="sig-name descname"><span class="pre">edit</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group/permissions.html#edit"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.permissions.edit" title="Permalink to this definition"></a></dt>
<dd><p>Updates the group with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>’s permissions.
Automatically creates them if they don’t exist.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.permissions.get_permissions">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.permissions.</span></span><span class="sig-name descname"><span class="pre">get_permissions</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">group_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">validate_existence</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="heiwa.database.html#heiwa.database.GroupPermissions" title="heiwa.database.group.permissions.GroupPermissions"><span class="pre">heiwa.database.group.permissions.GroupPermissions</span></a></span></span><a class="reference internal" href="_modules/heiwa/views/group/permissions.html#get_permissions"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.permissions.get_permissions" title="Permalink to this definition"></a></dt>
<dd><p>Gets the group permissions with the given <code class="docutils literal notranslate"><span class="pre">group_id</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>group_id</strong> – The
<a class="reference internal" href="heiwa.database.html#heiwa.database.GroupPermissions.group_id" title="heiwa.database.GroupPermissions.group_id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">group_id</span></code></a> of the
permissions to find.</p></li>
<li><p><strong>session</strong> – The session to find the permissions with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the permissions. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>validate_existence</strong> – Whether or not to check that the permissions exist.
<code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code> by default.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIGroupPermissionsNotFound" title="heiwa.exceptions.APIGroupPermissionsNotFound"><strong>heiwa.exceptions.APIGroupPermissionsNotFound</strong></a> – Raised when the
permissions don’t exist, or the <code class="docutils literal notranslate"><span class="pre">user</span></code> does not have permission to
view them. Depends on <code class="docutils literal notranslate"><span class="pre">validate_existence</span></code> being <code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code>.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The permissions.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.permissions.view">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.permissions.</span></span><span class="sig-name descname"><span class="pre">view</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group/permissions.html#view"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.permissions.view" title="Permalink to this definition"></a></dt>
<dd><p>Gets the group with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>’s permissions.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.permissions.view_allowed_actions_instance">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.permissions.</span></span><span class="sig-name descname"><span class="pre">view_allowed_actions_instance</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group/permissions.html#view_allowed_actions_instance"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.permissions.view_allowed_actions_instance" title="Permalink to this definition"></a></dt>
<dd><p>Gets all actions that <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to perform on the
group with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>’s permissions</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The ID of the group.</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIGroupNotFound" title="heiwa.exceptions.APIGroupNotFound"><strong>heiwa.exceptions.APIGroupNotFound</strong></a> – Raised when the <code class="docutils literal notranslate"><span class="pre">id_</span></code> does not
correspond to any group, or the current user does not have the permission
to view it.</p></li>
<li><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIGroupPermissionsNotFound" title="heiwa.exceptions.APIGroupPermissionsNotFound"><strong>heiwa.exceptions.APIGroupPermissionsNotFound</strong></a> – Raised when the group
does not have any set permissions.</p></li>
</ul>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of allowed actions, with the <code class="docutils literal notranslate"><span class="pre">200</span></code> HTTP status code.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.database.html#heiwa.database.GroupPermissions" title="heiwa.database.GroupPermissions"><code class="xref py py-class docutils literal notranslate"><span class="pre">heiwa.database.GroupPermissions</span></code></a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.permissions.view_allowed_actions_static">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.permissions.</span></span><span class="sig-name descname"><span class="pre">view_allowed_actions_static</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/group/permissions.html#view_allowed_actions_static"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.permissions.view_allowed_actions_static" title="Permalink to this definition"></a></dt>
<dd><p>Gets all actions that <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to perform on all
group permissions, regardless of which one they belong to.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of allowed actions, with the <code class="docutils literal notranslate"><span class="pre">200</span></code> HTTP status code.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.database.html#heiwa.database.GroupPermissions" title="heiwa.database.GroupPermissions"><code class="xref py py-class docutils literal notranslate"><span class="pre">heiwa.database.GroupPermissions</span></code></a></p>
</div>
</dd></dl>

</section>
<section id="module-heiwa.views.group.utils">
<span id="utilities"></span><h2>Utilities<a class="headerlink" href="#module-heiwa.views.group.utils" title="Permalink to this headline"></a></h2>
<p>Utilities specific to <a class="reference internal" href="heiwa.database.html#heiwa.database.Group" title="heiwa.database.Group"><code class="xref py py-class docutils literal notranslate"><span class="pre">Group</span></code></a> views, but not
only a single module.</p>
<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.group.utils.get_if_last_default_group">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.group.utils.</span></span><span class="sig-name descname"><span class="pre">get_if_last_default_group</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">group_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">bool</span></span></span><a class="reference internal" href="_modules/heiwa/views/group/utils.html#get_if_last_default_group"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.group.utils.get_if_last_default_group" title="Permalink to this definition"></a></dt>
<dd><p>Checks whether or not the <a class="reference internal" href="heiwa.database.html#heiwa.database.Group" title="heiwa.database.Group"><code class="xref py py-class docutils literal notranslate"><span class="pre">Group</span></code></a> with the
given <code class="docutils literal notranslate"><span class="pre">group_id</span></code> is the last whose
<a class="reference internal" href="heiwa.database.html#heiwa.database.Group.default_for" title="heiwa.database.Group.default_for"><code class="xref py py-attr docutils literal notranslate"><span class="pre">default_for</span></code></a> column contains <code class="docutils literal notranslate"><span class="pre">*</span></code> -
meaning it’s default for all users.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>group_id</strong> – The group’s <a class="reference internal" href="heiwa.database.html#heiwa.database.Group.id" title="heiwa.database.Group.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a>.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The result of the check.</p>
</dd>
</dl>
</dd></dl>

</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="heiwa.views.forum.html" class="btn btn-neutral float-left" title="Forums" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="heiwa.views.guest.html" class="btn btn-neutral float-right" title="Guests" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>